# coding: utf-8

"""
    Onboarding Buddy API Specification

    This specification details all the operations available to call in the Onboarding Buddy API

    The version of the OpenAPI document: v1
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from onboarding_buddy_client.models.email_individual_record_m import EmailIndividualRecordM
from onboarding_buddy_client.models.individual_address_m import IndividualAddressM
from onboarding_buddy_client.models.individual_alias_m import IndividualAliasM
from onboarding_buddy_client.models.other_sanction_record_m import OtherSanctionRecordM
from typing import Optional, Set
from typing_extensions import Self

class AircraftSanctionRecordM(BaseModel):
    """
    AircraftSanctionRecordM
    """ # noqa: E501
    full_name: Optional[StrictStr] = Field(default=None, alias="fullName")
    program: Optional[StrictStr] = None
    manufacture_date: Optional[StrictStr] = Field(default=None, alias="manufactureDate")
    model: Optional[StrictStr] = None
    operator: Optional[StrictStr] = None
    manufacturer_serial_number: Optional[StrictStr] = Field(default=None, alias="manufacturerSerialNumber")
    tail_number: Optional[StrictStr] = Field(default=None, alias="tailNumber")
    construction_number: Optional[StrictStr] = Field(default=None, alias="constructionNumber")
    previous_tail_number: Optional[StrictStr] = Field(default=None, alias="previousTailNumber")
    mode_s_transponder_code: Optional[StrictStr] = Field(default=None, alias="modeSTransponderCode")
    serial_identification: Optional[StrictStr] = Field(default=None, alias="serialIdentification")
    additional_info: Optional[List[StrictStr]] = Field(default=None, alias="additionalInfo")
    alias_list: Optional[List[IndividualAliasM]] = Field(default=None, alias="aliasList")
    address_list: Optional[List[IndividualAddressM]] = Field(default=None, alias="addressList")
    nationality: Optional[StrictStr] = None
    linked_to: Optional[StrictStr] = Field(default=None, alias="linkedTo")
    secondary_sanctions_risk: Optional[StrictStr] = Field(default=None, alias="secondarySanctionsRisk")
    also_known_as: Optional[List[StrictStr]] = Field(default=None, alias="alsoKnownAs")
    linked_individuals: Optional[List[EmailIndividualRecordM]] = Field(default=None, alias="linkedIndividuals")
    linked_entity: Optional[List[OtherSanctionRecordM]] = Field(default=None, alias="linkedEntity")
    __properties: ClassVar[List[str]] = ["fullName", "program", "manufactureDate", "model", "operator", "manufacturerSerialNumber", "tailNumber", "constructionNumber", "previousTailNumber", "modeSTransponderCode", "serialIdentification", "additionalInfo", "aliasList", "addressList", "nationality", "linkedTo", "secondarySanctionsRisk", "alsoKnownAs", "linkedIndividuals", "linkedEntity"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of AircraftSanctionRecordM from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in alias_list (list)
        _items = []
        if self.alias_list:
            for _item_alias_list in self.alias_list:
                if _item_alias_list:
                    _items.append(_item_alias_list.to_dict())
            _dict['aliasList'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in address_list (list)
        _items = []
        if self.address_list:
            for _item_address_list in self.address_list:
                if _item_address_list:
                    _items.append(_item_address_list.to_dict())
            _dict['addressList'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in linked_individuals (list)
        _items = []
        if self.linked_individuals:
            for _item_linked_individuals in self.linked_individuals:
                if _item_linked_individuals:
                    _items.append(_item_linked_individuals.to_dict())
            _dict['linkedIndividuals'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in linked_entity (list)
        _items = []
        if self.linked_entity:
            for _item_linked_entity in self.linked_entity:
                if _item_linked_entity:
                    _items.append(_item_linked_entity.to_dict())
            _dict['linkedEntity'] = _items
        # set to None if full_name (nullable) is None
        # and model_fields_set contains the field
        if self.full_name is None and "full_name" in self.model_fields_set:
            _dict['fullName'] = None

        # set to None if program (nullable) is None
        # and model_fields_set contains the field
        if self.program is None and "program" in self.model_fields_set:
            _dict['program'] = None

        # set to None if manufacture_date (nullable) is None
        # and model_fields_set contains the field
        if self.manufacture_date is None and "manufacture_date" in self.model_fields_set:
            _dict['manufactureDate'] = None

        # set to None if model (nullable) is None
        # and model_fields_set contains the field
        if self.model is None and "model" in self.model_fields_set:
            _dict['model'] = None

        # set to None if operator (nullable) is None
        # and model_fields_set contains the field
        if self.operator is None and "operator" in self.model_fields_set:
            _dict['operator'] = None

        # set to None if manufacturer_serial_number (nullable) is None
        # and model_fields_set contains the field
        if self.manufacturer_serial_number is None and "manufacturer_serial_number" in self.model_fields_set:
            _dict['manufacturerSerialNumber'] = None

        # set to None if tail_number (nullable) is None
        # and model_fields_set contains the field
        if self.tail_number is None and "tail_number" in self.model_fields_set:
            _dict['tailNumber'] = None

        # set to None if construction_number (nullable) is None
        # and model_fields_set contains the field
        if self.construction_number is None and "construction_number" in self.model_fields_set:
            _dict['constructionNumber'] = None

        # set to None if previous_tail_number (nullable) is None
        # and model_fields_set contains the field
        if self.previous_tail_number is None and "previous_tail_number" in self.model_fields_set:
            _dict['previousTailNumber'] = None

        # set to None if mode_s_transponder_code (nullable) is None
        # and model_fields_set contains the field
        if self.mode_s_transponder_code is None and "mode_s_transponder_code" in self.model_fields_set:
            _dict['modeSTransponderCode'] = None

        # set to None if serial_identification (nullable) is None
        # and model_fields_set contains the field
        if self.serial_identification is None and "serial_identification" in self.model_fields_set:
            _dict['serialIdentification'] = None

        # set to None if additional_info (nullable) is None
        # and model_fields_set contains the field
        if self.additional_info is None and "additional_info" in self.model_fields_set:
            _dict['additionalInfo'] = None

        # set to None if alias_list (nullable) is None
        # and model_fields_set contains the field
        if self.alias_list is None and "alias_list" in self.model_fields_set:
            _dict['aliasList'] = None

        # set to None if address_list (nullable) is None
        # and model_fields_set contains the field
        if self.address_list is None and "address_list" in self.model_fields_set:
            _dict['addressList'] = None

        # set to None if nationality (nullable) is None
        # and model_fields_set contains the field
        if self.nationality is None and "nationality" in self.model_fields_set:
            _dict['nationality'] = None

        # set to None if linked_to (nullable) is None
        # and model_fields_set contains the field
        if self.linked_to is None and "linked_to" in self.model_fields_set:
            _dict['linkedTo'] = None

        # set to None if secondary_sanctions_risk (nullable) is None
        # and model_fields_set contains the field
        if self.secondary_sanctions_risk is None and "secondary_sanctions_risk" in self.model_fields_set:
            _dict['secondarySanctionsRisk'] = None

        # set to None if also_known_as (nullable) is None
        # and model_fields_set contains the field
        if self.also_known_as is None and "also_known_as" in self.model_fields_set:
            _dict['alsoKnownAs'] = None

        # set to None if linked_individuals (nullable) is None
        # and model_fields_set contains the field
        if self.linked_individuals is None and "linked_individuals" in self.model_fields_set:
            _dict['linkedIndividuals'] = None

        # set to None if linked_entity (nullable) is None
        # and model_fields_set contains the field
        if self.linked_entity is None and "linked_entity" in self.model_fields_set:
            _dict['linkedEntity'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of AircraftSanctionRecordM from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "fullName": obj.get("fullName"),
            "program": obj.get("program"),
            "manufactureDate": obj.get("manufactureDate"),
            "model": obj.get("model"),
            "operator": obj.get("operator"),
            "manufacturerSerialNumber": obj.get("manufacturerSerialNumber"),
            "tailNumber": obj.get("tailNumber"),
            "constructionNumber": obj.get("constructionNumber"),
            "previousTailNumber": obj.get("previousTailNumber"),
            "modeSTransponderCode": obj.get("modeSTransponderCode"),
            "serialIdentification": obj.get("serialIdentification"),
            "additionalInfo": obj.get("additionalInfo"),
            "aliasList": [IndividualAliasM.from_dict(_item) for _item in obj["aliasList"]] if obj.get("aliasList") is not None else None,
            "addressList": [IndividualAddressM.from_dict(_item) for _item in obj["addressList"]] if obj.get("addressList") is not None else None,
            "nationality": obj.get("nationality"),
            "linkedTo": obj.get("linkedTo"),
            "secondarySanctionsRisk": obj.get("secondarySanctionsRisk"),
            "alsoKnownAs": obj.get("alsoKnownAs"),
            "linkedIndividuals": [EmailIndividualRecordM.from_dict(_item) for _item in obj["linkedIndividuals"]] if obj.get("linkedIndividuals") is not None else None,
            "linkedEntity": [OtherSanctionRecordM.from_dict(_item) for _item in obj["linkedEntity"]] if obj.get("linkedEntity") is not None else None
        })
        return _obj


