# coding: utf-8

"""
    Onboarding Buddy API Specification

    This specification details all the operations available to call in the Onboarding Buddy API

    The version of the OpenAPI document: v1
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field
from typing import Any, ClassVar, Dict, List, Optional
from onboarding_buddy_client.models.email_entity_record_m import EmailEntityRecordM
from onboarding_buddy_client.models.email_individual_record_m import EmailIndividualRecordM
from typing import Optional, Set
from typing_extensions import Self

class EmailSanctionRecordM(BaseModel):
    """
    EmailSanctionRecordM
    """ # noqa: E501
    individual_match: Optional[List[EmailIndividualRecordM]] = Field(default=None, alias="individualMatch")
    entity_match: Optional[List[EmailEntityRecordM]] = Field(default=None, alias="entityMatch")
    __properties: ClassVar[List[str]] = ["individualMatch", "entityMatch"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of EmailSanctionRecordM from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in individual_match (list)
        _items = []
        if self.individual_match:
            for _item_individual_match in self.individual_match:
                if _item_individual_match:
                    _items.append(_item_individual_match.to_dict())
            _dict['individualMatch'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in entity_match (list)
        _items = []
        if self.entity_match:
            for _item_entity_match in self.entity_match:
                if _item_entity_match:
                    _items.append(_item_entity_match.to_dict())
            _dict['entityMatch'] = _items
        # set to None if individual_match (nullable) is None
        # and model_fields_set contains the field
        if self.individual_match is None and "individual_match" in self.model_fields_set:
            _dict['individualMatch'] = None

        # set to None if entity_match (nullable) is None
        # and model_fields_set contains the field
        if self.entity_match is None and "entity_match" in self.model_fields_set:
            _dict['entityMatch'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of EmailSanctionRecordM from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "individualMatch": [EmailIndividualRecordM.from_dict(_item) for _item in obj["individualMatch"]] if obj.get("individualMatch") is not None else None,
            "entityMatch": [EmailEntityRecordM.from_dict(_item) for _item in obj["entityMatch"]] if obj.get("entityMatch") is not None else None
        })
        return _obj


