# coding: utf-8

"""
    Onboarding Buddy API Specification

    This specification details all the operations available to call in the Onboarding Buddy API

    The version of the OpenAPI document: v1
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class IndividualAddressM(BaseModel):
    """
    IndividualAddressM
    """ # noqa: E501
    address: Optional[StrictStr] = None
    city_state_province_postal_code: Optional[StrictStr] = Field(default=None, alias="cityStateProvincePostalCode")
    country: Optional[StrictStr] = None
    address_remarks: Optional[StrictStr] = Field(default=None, alias="addressRemarks")
    __properties: ClassVar[List[str]] = ["address", "cityStateProvincePostalCode", "country", "addressRemarks"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of IndividualAddressM from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # set to None if address (nullable) is None
        # and model_fields_set contains the field
        if self.address is None and "address" in self.model_fields_set:
            _dict['address'] = None

        # set to None if city_state_province_postal_code (nullable) is None
        # and model_fields_set contains the field
        if self.city_state_province_postal_code is None and "city_state_province_postal_code" in self.model_fields_set:
            _dict['cityStateProvincePostalCode'] = None

        # set to None if country (nullable) is None
        # and model_fields_set contains the field
        if self.country is None and "country" in self.model_fields_set:
            _dict['country'] = None

        # set to None if address_remarks (nullable) is None
        # and model_fields_set contains the field
        if self.address_remarks is None and "address_remarks" in self.model_fields_set:
            _dict['addressRemarks'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of IndividualAddressM from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "address": obj.get("address"),
            "cityStateProvincePostalCode": obj.get("cityStateProvincePostalCode"),
            "country": obj.get("country"),
            "addressRemarks": obj.get("addressRemarks")
        })
        return _obj


