# coding: utf-8

"""
    Onboarding Buddy API Specification

    This specification details all the operations available to call in the Onboarding Buddy API

    The version of the OpenAPI document: v1
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictInt, StrictStr, field_validator
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class MobileNumberResultM(BaseModel):
    """
    MobileNumberResultM
    """ # noqa: E501
    number: Optional[StrictStr] = None
    valid: Optional[StrictBool] = None
    local_format: Optional[StrictStr] = Field(default=None, alias="localFormat")
    international_format: Optional[StrictStr] = Field(default=None, alias="internationalFormat")
    country_prefix: Optional[StrictStr] = Field(default=None, alias="countryPrefix")
    country_code: Optional[StrictStr] = Field(default=None, alias="countryCode")
    carrier: Optional[StrictStr] = None
    line_type: Optional[StrictStr] = Field(default=None, alias="lineType")
    check_status: Optional[StrictStr] = Field(default=None, alias="checkStatus")
    __properties: ClassVar[List[str]] = ["number", "valid", "localFormat", "internationalFormat", "countryPrefix", "countryCode", "carrier", "lineType", "checkStatus"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of MobileNumberResultM from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # set to None if number (nullable) is None
        # and model_fields_set contains the field
        if self.number is None and "number" in self.model_fields_set:
            _dict['number'] = None

        # set to None if local_format (nullable) is None
        # and model_fields_set contains the field
        if self.local_format is None and "local_format" in self.model_fields_set:
            _dict['localFormat'] = None

        # set to None if international_format (nullable) is None
        # and model_fields_set contains the field
        if self.international_format is None and "international_format" in self.model_fields_set:
            _dict['internationalFormat'] = None

        # set to None if country_prefix (nullable) is None
        # and model_fields_set contains the field
        if self.country_prefix is None and "country_prefix" in self.model_fields_set:
            _dict['countryPrefix'] = None

        # set to None if country_code (nullable) is None
        # and model_fields_set contains the field
        if self.country_code is None and "country_code" in self.model_fields_set:
            _dict['countryCode'] = None

        # set to None if carrier (nullable) is None
        # and model_fields_set contains the field
        if self.carrier is None and "carrier" in self.model_fields_set:
            _dict['carrier'] = None

        # set to None if line_type (nullable) is None
        # and model_fields_set contains the field
        if self.line_type is None and "line_type" in self.model_fields_set:
            _dict['lineType'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of MobileNumberResultM from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "number": obj.get("number"),
            "valid": obj.get("valid"),
            "localFormat": obj.get("localFormat"),
            "internationalFormat": obj.get("internationalFormat"),
            "countryPrefix": obj.get("countryPrefix"),
            "countryCode": obj.get("countryCode"),
            "carrier": obj.get("carrier"),
            "lineType": obj.get("lineType"),
            "checkStatus": obj.get("checkStatus")
        })
        return _obj


